#!/usr/local/bin/python

from Tkinter  import *            # widget classes
from guimixin import GuiMixin     # mix-in methods
from guimaker import GuiMaker     # frame, plus menu/tool-bar builder

class Hello(GuiMixin, GuiMaker):
    def start(self):
        self.hellos = 1
        self.master.title("GuiMaker Demo")
        self.master.iconname("GuiMaker")

        self.menuBar = [                               # a tree: 3 pulldowns
          ('File', 0,                                  # (pull-down)
              [('New...',  0, self.notdone),           # [menu items list]
               ('Open...', 0, self.fileOpen), 
               ('Quit',    0, self.quit)]              # label,underline,action
          ),

          ('Edit', 0,
              [('Cut',  -1, lambda:0),                 # no underline|action
               ('Paste',-1, lambda:0), 
               'separator',                            # add a separator
               ('Stuff', -1, 
                   [('Clone', -1, self.clone),         # cascaded submenu
                    ('More',  -1, self.more)] 
               ),
               ('Delete', -1, lambda:0),
               [5]]                                    # disable 'delete'
          ),

          ('Play', 0,
              [('Hello',     0, self.greeting),
               ('Popup...',  0, self.dialog),
               ('Demos', 0,
                  [('Hanoi', -1, lambda x=self: x.spawn('guido/hanoi.py', 1)),
                   ('Pong',  -1, lambda x=self: x.spawn('matt/pong-demo-1.py'))]
               )]
          )]

        self.toolBar = [
          ('Quit',  self.quit,     {'side': 'right'}),      # add 3 buttons
          ('Hello', self.greeting, {'side': 'left'}),
          ('Popup', self.dialog,   {'side': 'left', 'expand':1 }) ]

    def makeWidgets(self):                                  # override default
        Label(self, {'text':   'Hello maker world!',        # add middle part
                     'cursor': 'pencil',
                      Pack:    {'padx': 50, 'pady':50, 
                                'expand':'yes', 'fill':'both'} })

    def greeting(self):
        self.hellos = self.hellos + 1
        if self.hellos % 3:
            print "hi"
        else:
            self.infobox("Gotcha'", 'HELLO!')    # on every third press

    def dialog(self):
        button = self.question('OOPS!', 'You typed "rm*" ... continue?', 
                               'questhead', ('yes', 'no', 'help'))
        [lambda:0, self.quit, self.help][button]()

    def fileOpen(self):
        self.browser('big_gui2.py')       # browse self; hmm...

    def more(self):
        new = Toplevel()
        new.label = Label(new, {'text': 'A new non-modal window'})
        new.label.pack()
        Button(new, {'text':'Quit', 'command':self.quit, Pack:{'side':'left'}})
        Button(new, {'text':'More', 'command':self.more, Pack:{'side':'right'}})

if __name__ == '__main__':  Hello().mainloop()   
