# a "mixin" class for other frames 
# list before Frame to override Frame.quit
# common methods for canned-dialogs, spawning, etc.

PDIR = '/home/mark/python-1.2/Python-1.2'    # path to 'python'

from Tkinter import *
from Dialog import Dialog
from ScrolledText import ScrolledText

class GuiMixin:
    def question(self, title, text, bitmap='question', strings=('Yes', 'No')):
        return Dialog(self, {'title':  title,
                             'text':   text,
                             'bitmap': bitmap,
                             'default': 1, 'strings': strings }).num

    def infobox(self, title, text, bitmap='', strings=('OK',)):
        Dialog(self, {'title': title, 
                      'text':  text, 
                      'default': 0, 'bitmap': bitmap, 'strings': strings })

    def quit(self):
        ans = self.question('Verify quit', 'Are you sure you want to quit?')
        if ans == 0: 
            Frame.quit(self)

    def notdone(self):
        self.infobox('Not implemented', 'Option not available', 'error')

    def help(self):
        self.infobox('RTFM', 'See figure 1...', 'info')   # override below

    def errorbox(self, text):
        self.infobox('Error!', text, 'error')

    def clone(self):
        new = Toplevel()               # make a new version of me
        myclass = self.__class__       # instance's (lowest) class object
        myclass(new).mainloop()        # not Hello(self)

    def spawn(self, demo, fork=0):
        import os                                # run /Demo program by name
        try:
            pbase = os.environ['PYTHONBASE']     # env var overrides
        except:
            pbase = PDIR
        python = pbase + '/python'
        if not fork:
            os.system('%s %s/Demo/tkinter/%s' % (python, pbase, demo) ) 
        else:
            pid = os.fork()
            if pid == 0:
                os.execv(python, (python, pbase+'/Demo/tkinter/'+demo))

    def browser(self, file):
        new  = Toplevel()
        new.minsize(1,1)   # resizable
        text = ScrolledText(new, {'height':30, 'width':90, Pack:{} })
        new.title("Poor-man's Text Editor")
        new.iconname("browser")
        text.insert('0.0', open(file, 'r').read() )
